#This file calls paup to perform an MP TBR search from a starting tree.
#Copyright (C) 2004 The University of Texas at Austin
#
#This program is free software; you can redistribute it and/or modify it
#under the terms of the GNU General Public License as published by the Free
#Software Foundation; either version 2 of the License, or (at your option)
#any later version.
#
#This program is distributed in the hope that it will be useful, but WITHOUT
#ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
#more details.
#
#You should have received a copy of the GNU General Public License along 
#with this program; if not, write to the Free Software Foundation, Inc., 59 
#Temple Place - Suite 330, Boston, MA 02111-1307, USA.
#
#Email: usman@cs.njit.edu
#Mail: Usman Roshan, Department of Computer Sciences, NJIT-CCS, Computer
#Science Department, GITC 4400, University Heights, Newark, NJ 07102

$input = shift;
$start = shift;
$outtree = shift;
$scorefile = shift;
$file_suffix = shift;

open(IN, $input); 
$l = <IN>;
my @temp = split(/\s+/, $l);
if ($temp[0] !~ /\d/) {
  $number_of_leaves = $temp[1];
  $seq_length = $temp[2];
}
else {
  $number_of_leaves = $temp[0];
  $seq_length = $temp[1];
}
my $taxa = "", $count = 0;
while($count < $number_of_leaves) {
  $_ = <IN>;
  @temp = split(/\s+/, $_);
  $taxa .= $temp[0]." ";
  $count++;
}
close IN;

open(PAUP_FILE, ">mptbr_start_in".$file_suffix);
print PAUP_FILE "#NEXUS\nbegin paup;set Monitor=yes maxtrees=1 increase=no;\nend;\n";
print PAUP_FILE "begin taxa;\ndimensions ntax=$number_of_leaves".";\n";
print PAUP_FILE "taxlabels $taxa".";\nend;\n";
print PAUP_FILE "begin characters;\ndimensions nchar=$seq_length".";\n";
print PAUP_FILE "format datatype=nucleotide gap=- missing=?;\nmatrix\n";

open(IN, $input);
<IN>; my $count = 0;

while ($count < $number_of_leaves) {
  $_ = <IN>;
  print PAUP_FILE $_;
  $count++;
}
close IN;
print PAUP_FILE ";\nend;\n";

my $start_tree = "";
open(START, $start);
$start_tree = <START>;

if ($start_tree !~ /\w/) {print "Error: no starting tree found\n";exit;}

print PAUP_FILE "begin tree;\n";
print PAUP_FILE "tree tree_0"." = \[&U\] $start_tree;\n";
print PAUP_FILE "end;\n";

srand;
my $x = rand 100000;
my $seed = int $x;

print PAUP_FILE "begin paup;\n";
print PAUP_FILE "hsearch start=current swap=tbr dstatus=60 timelimit=3600;\n";
print PAUP_FILE "filter best=yes;\n";
print PAUP_FILE "savetrees file=$outtree brlens=yes replace=yes format=phylip;\n";
print PAUP_FILE "quit;\n"; 
print PAUP_FILE "end;\n";
close PAUP_FILE;

system "paup -n -u mptbr_start_in$file_suffix > junk$file_suffix";
system "/bin/rm mptbr_start_in$file_suffix";

system "perl paup_mpscore.pl $input $outtree $scorefile $fs > junk$file_suffix";
system "/bin/rm junk$file_suffix";
open(IN, $scorefile);
$l=<IN>; $l=<IN>; close IN;
chomp $l; @tmp=split(/\s+/, $l);
open(OUT, ">$scorefile");
print OUT $tmp[1]; close OUT;

