#ifndef PHYLO_TREE
#define PHYLO_TREE

#include<ugraph.h>
#include<constants.h>

typedef struct phylogenetic_tree_struct* phylogenetic_tree;
typedef struct phylo_tree_node_struct* phylo_tree_node;
typedef struct phylo_tree_edge_struct* phylo_tree_edge;

struct phylo_tree_node_struct {
  
  node n;
  int taxon_id;
  int taxa_size;
}

struct phylo_tree_edge_struct {
  
  edge e;
}

struct phylogenetic_tree_struct {
 
  ugraph G;
  char* num_to_name[MAX_LEAVES];
  int num_leaves;
};

phylogenetic_tree new_phylogenetic_tree();
phylo_tree_node new_phylo_tree_node(phylogenetic_tree T);
phylo_tree_edge new_phylo_tree_edge(phylogenetic_tree T, phylo_tree_node u,
				    phylo_tree_node v, double wgt);
#endif
