#ifndef UGRAPH
#define UGRAPH

/*Data structures*/
typedef struct node_struct* node;
typedef struct edge_struct* edge;
typedef struct ugraph_struct* ugraph;

struct node_struct {
 
  node prev;
  node next;
  edge first_edge;
  edge last_edge;

  int degree;
  unsigned id;

  void* aux_vars;
};

struct edge_struct {

  node u;
  node v;
  
  edge prev;
  edge next;
  
  edge u_next;
  edge u_prev;
  
  edge v_next;
  edge v_prev;
  
  unsigned id;
  
  void* aux_vars;
};

struct ugraph_struct {
  
  edge first_edge;
  edge last_edge;
  node first_node;
  node last_node;
  
  int n_edges;
  int n_nodes;
  
  unsigned id_edges;
  unsigned id_nodes;
};

/*Functions on structures*/
node new_node(ugraph G, void* aux_vars_);
void del_node(ugraph G, node u);

edge new_edge(ugraph G, node u, node v, void* aux_vars_);
void del_edge(ugraph G, edge e);

ugraph new_graph();
void del_graph(ugraph G);

void print_graph(ugraph G);

node opposite(node u, edge e);
#endif












































