#include<hashtable2.h>
#include<string.h>
#include<stdlib.h>
#include<stdio.h>

int probelength_hashtable2(hashtable2 ht){return ht->probelength_;}

void del_hashtable2(hashtable2 ht){
  int i;
  for(i=0;i<ht->size_;i++)
    if(ht->table_[i]) {free(ht->table_[i]->value); free(ht->table_[i]);}
  free(ht->table_);
}    

hashtable2 new_hashtable2(long sz){
  int i;
  hashtable2 ht;
  
  ht = (hashtable2) malloc(sizeof(struct hashtable2_struct));
  ht->size_ = sz;
  
  /* allocate memory for table*/
  ht->table_ = (hashtable2_node*) malloc(ht->size_*sizeof(hashtable2_node)); 

  /* initialize to NULLS*/
  for(i = 0; i < ht->size_; i++) ht->table_[i] = 0; 
  ht->P_ = 2147483647; /* initialize P (large prime)*/
  ht->probelength_ = 0;
  
  /*initialize hash2_1 and hash2_2 variables*/
  ht->a1_ = drand48() * (ht->P_ - 1) + 1;
  ht->a2_ = drand48() * (ht->P_ - 1) + 1;
  ht->b1_ = drand48() * ht->P_;
  ht->b2_ = drand48() * ht->P_;

  return ht;
}

/* This is called before hash2_1 and hash2_2. It sets the 
   value of h_ to be used by hash2_1 and hash2_2 and saves excessive calls
   to the hash function.*/
unsigned int hash_2(hashtable2 ht, unsigned int key) {
  key += (key << 12);
  key ^= (key >> 22);
  key += (key << 4);
  key ^= (key >> 9);
  key += (key << 10);
  key ^= (key >> 2);
  key += (key << 7);
  key ^= (key >> 12);
  return key;
}

unsigned long hash2_1(hashtable2 ht) {
  return ((((ht->a1_ * ht->h_) + ht->b1_) % ht->P_) % ht->size_) ;
}

unsigned long hash2_2(hashtable2 ht) {
  return ((((ht->a2_ * ht->h_ + ht->b2_) % ht->P_) % (ht->size_ - 3)) | 1);
}

void insert_hashtable2(hashtable2 ht, unsigned int key, void* value) {
  unsigned long i;
  int h1, h2;
  
  hash_2(ht, key);
  h1 = hash2_1(ht);
  h2 = hash2_2(ht);
  
  ht->probelength_ = 0;
  
  for(i = h1; ht->table_[i]; i = (i + h2) % ht->size_){
    ht->probelength_++;
    if(ht->table_[i]->key == key) return;
  }
  
  ht->table_[i] = malloc(sizeof(struct hashtable2_node_struct));
  ht->table_[i]->key = key;
  ht->table_[i]->value = value;
  
  return;
}
    
void* lookup_hashtable2(hashtable2 ht, unsigned int key) {
  unsigned long i;
  int h1, h2;
  
  hash_2(ht, key);
  h1 = hash2_1(ht);
  h2 = hash2_2(ht);
  
  ht->probelength_ = 0;

  for(i = h1; ht->table_[i]; i = (i + h2) % ht->size_) {
    ht->probelength_++;
    if(!(ht->table_[i])) return 0;
    else if(ht->table_[i] && ht->table_[i]->key == key) 
      return ht->table_[i]->value;
  }
  
  return 0;
}

