/*! \file hashtable2.h
\brief Contains definition for a hash table structure which
uses integers as keys and void* for values
*/

#ifndef HASHTABLE2
#define HASHTABLE2

typedef struct hashtable2_struct* hashtable2;

typedef struct hashtable2_node_struct* hashtable2_node;

struct hashtable2_node_struct {
  int key;
  void* value;
};

struct hashtable2_struct { 
  
  /*size is size of table*/
  long size_;
  
  /*number of collisions before empty slot is found*/
  int probelength_;
  
  /* hash sets this value.  it is used in hash1 and hash2
     to avoid calling hash again (efficiency reasons) */
  unsigned long h_;
  
  /*random values used in hash functions.*/
  unsigned long a1_, a2_, b1_, b2_, P_;
  
  hashtable2_node* table_;
};

/*hash functions*/
unsigned int hash_2(hashtable2 ht, unsigned int key);
inline unsigned long hash2_1 (hashtable2 ht);
inline unsigned long hash2_2 (hashtable2 ht);

/*dictionary operations*/
void  insert_hashtable2 (hashtable2 ht, unsigned int key, void* value);
void* lookup_hashtable2 (hashtable2 ht, unsigned int key);

int probelength_hashtable2(hashtable2 ht);

/*constructor*/
hashtable2 new_hashtable2(long sz);             

/*destructor*/
void del_hashtable2(hashtable2 ht);

#endif
