/*! \file list.h
\brief Contains definition for a list structure
*/

#ifndef LIST
#define LIST

typedef struct list_struct* list;

typedef struct list_node_struct* list_node;

struct list_node_struct {
  void* data;
  list_node next;
  list_node prev;
};

struct list_struct { 
  list_node head;
  list_node tail;
  int size;
};

/*constructors*/
list new_list();             
list_node new_list_node(void* v);

/*destructor*/
void del_list(list l);
void del_list_node(list_node n);

/*operations*/
list_node append_list(list l, void* v);
list_node insert_list(list l, void* v, list_node n, int where);
void* pop_list(list l);
void push_list(list l, void* d);

#endif
