/*! \file split.h
\brief Contains definitions for a split (bipartition) structure
*/

#ifndef SPLIT
#define SPLIT

#include<int_set.h>

typedef struct split_struct* split;

struct split_struct { 
  int_set A;
  double wgt;
};

/*constructor*/
split new_split();             

/*destructor*/
void del_split(split s);

/*operations*/
int_set get_A_split(split s);
int_set get_B_split(split s, int_set ts);
void set_split(split s, int_set A, int_set B, double wgt);

#endif




