/*
This file implements a bipartition structure.
Copyright (C) 2004 The University of Texas at Austin

Based upon Daniel Huson's implementation. 

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your option)
any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc., 59
Temple Place - Suite 330, Boston, MA 02111-1307, USA.

Email: usman@cs.njit.edu
Mail: Usman Roshan, Department of Computer Sciences, NJIT-CCS, Computer
Science Department, GITC 4400, University Heights, Newark, NJ 07102
*/

/*! \file split.h
\brief Contains definitions for a split (bipartition) structure
*/

#ifndef SPLIT
#define SPLIT

#include<int_set.h>

typedef struct split_struct* split;

struct split_struct { 
  int_set A;
  int_set B;
  double wgt;
};

/*constructor*/
split new_split();             

/*destructor*/
void del_split(split s);

/*operations*/
int_set get_A_split(split s);
int_set get_B_split(split s);
void set_split(split s, int_set A, int_set B, double wgt);
void print_split(split s);
void print_split2(split s, char** num_to_name);
void print_split3(split s, int_set taxa);

#endif




