#include<string.h>
#include<stdio.h>
#include<stdlib.h>
#include<tree2splits.h>
#include<splits2tree.h>
#include<constants.h>
#include<phylo_tree.h>
#include<split.h>

int VERBOSE=0;

int main(int argc, char* argv[]){

  char newick_tree[MAX_NEWICK_STR_LEN];
  char newick_tree2[MAX_NEWICK_STR_LEN];
  char** num_to_name;
  FILE* fp; int i, j; 
  phylogenetic_tree T, U;
  list listsplits; int_set taxa; list_node ln;
  node v;

  if(argc < 2){
    printf("Please specify guide tree using \"-gt <filename containing guide_tree>\"\n");
    exit(EXIT_FAILURE);
  }
  for(i = 1; i < argc; i++) {
    /*read in the newick tree*/
    if (!strcmp(argv[i], "-gt")) {
      i++;
      fp = fopen(argv[i], "r");
      if(!fp) {
        printf("Error: could not open filename \"%s\"\n", argv[i]);
        exit(EXIT_FAILURE);
      }
      fscanf(fp, "%s", newick_tree);
      fclose(fp);
    }
    else if (!strcmp(argv[i], "-v")){
      i++;
      sscanf(argv[i], "%d", &VERBOSE);
    }
    else {
      printf("Please specify guide tree using \"-gt <filename containing guide_tree>\"\n");
    }
  }
  
  num_to_name= (char**) malloc(MAX_LEAVES * sizeof(char*));
  T = new_phylogenetic_tree();
  if(!read_tree(T, num_to_name, newick_tree, 0)) {
    printf("Error: could not read tree %s\n", newick_tree);
    exit(EXIT_FAILURE);
  }

  print_graph(T->G);  
  del_phylogenetic_tree(T);
  for(i=0;i<MAX_LEAVES;i++)if(num_to_name[i])free(num_to_name[i]);
  free(num_to_name);
}
