#include<phylo_tree.h>
#include<ugraph.h>
#include<ugraph_aux_vars.h>
#include<stdlib.h> 
#include<time.h>
#include<list.h>

int main(){

  phylogenetic_tree T;
  char** num_to_name;
  char newick_tree[10000];
  int i; node v; 
  edge e; list edges; list_node ln;

  num_to_name = (char**) malloc(500 * sizeof(char*));
  for(i = 0;i < 500; i++){
    num_to_name[i] = (char*) malloc(500 * sizeof(char));
    sprintf(num_to_name[i], "%d", i);
  }

  T = uniform_random_tree(20);

  for(v=T->G->first_node; v; v=v->next)
    if(v->degree==1)
      insert_int_set(((node_aux_vars)v->aux_vars)->taxaset,
		     ((node_aux_vars)v->aux_vars)->taxon_id);
  
  srand(time(NULL));
  edges = new_list();
  for(e=T->G->first_edge; e; e=e->next)
    if(e->u->degree>1 && e->v->degree>1)
      if((double)rand()/(double)RAND_MAX > 0.5) push_list(edges, (void*) e);
  
  printf("deleting %d edges\n", size_list(edges));
  for(ln=edges->head; ln; ln=ln->next){
    del_edge(T->G, (edge)ln->data); T->num_leaves--;
  }
  
  print_phylo_tree(T, num_to_name);
  random_refine(T);
  print_phylo_tree(T, num_to_name);
}

