#include<string.h>
#include<stdio.h>
#include<stdlib.h>
#include<tree2splits.h>
#include<splits2tree.h>
#include<constants.h>
#include<phylo_tree.h>
#include<hashtable.h>
#include<assert.h>
#include<list.h>
#include<split.h>
#include<scm.h>

int VERBOSE=0;

void read_splits(FILE* fp, list listsplits, int_set* taxa);

int main(int argc, char* argv[]){

  char* out_tree;
  FILE* fp; int i, j; 
  phylogenetic_tree* tree_array;
  list* list_array;
  int_set* taxa_array;
  char** num_to_name;
  char** sequences;
  int ntax, nchars;
  hashtable name_to_num;
  int num_trees;
  node v;
  list_node ln, ln2;
  list scm_splits, listsplits;
  phylogenetic_tree scm_tree;
  int_set X, A, B, taxa;
  split S; 
  int t; char buffer[50]; char newick_tree[1000];


  if(argc < 2){
    printf("Please specify guide tree using \"-gt <filename containing guide_tree>\"\n");
    exit(EXIT_FAILURE);
  }
  for(i = 1; i < argc; i++) {
    if (!strcmp(argv[i], "-sp")) {
      i++;
      fp = fopen(argv[i], "r");
      if(!fp) {
        printf("Error: could not open filename \"%s\"\n", argv[i]);
        exit(EXIT_FAILURE);
      }
      listsplits=new_list();
      read_splits(fp, listsplits, &taxa);
      printf("size of listsplits=%d\n", size_list(listsplits));
      fclose(fp);
    }
    else if (!strcmp(argv[i], "-v")){
      i++;
      sscanf(argv[i], "%d", &VERBOSE);
    }
    else {
      printf("Please specify dataset using \"-s <filename containing sequences in phylip format>\"\n");
    }
  }

  scm_tree = new_phylogenetic_tree();
  splits2tree(listsplits, taxa, scm_tree);
  printf("tree has %d nodes and %d edges\n", scm_tree->G->n_nodes, scm_tree->G->n_edges);
  for(v = scm_tree->G->first_node; v; v=v->next){
    A = ((node_aux_vars)v->aux_vars)->taxaset;
    if(A->nelements){
      for(t=A->min; t<=A->max; t++){
	if(member_int_set(A, t)){
	  sprintf(buffer, "s%d", t);
	  scm_tree->num_to_name[t] = (char*)MALLOC(100*sizeof(char));
	  strcpy(scm_tree->num_to_name[t], buffer);
	}
      }
    }
  }
  print_tree(scm_tree, newick_tree, 1);
  printf("%s\n", newick_tree);
}

void read_splits(FILE* fp, list listsplits, int_set* taxa_){
 
 int_set A, taxa, B;
 char*  buffer; char* buffer2; char* endptr;
 int t, x, first;
 split sp;

 buffer=(char*) malloc(10000);
 buffer2=(char*) malloc(10);

 endptr=0; first=1;
 while(fgets(buffer, 5000, fp) != NULL){
  A = new_int_set(10);
  buffer2=buffer;
  t = strtol(buffer2, &endptr, 10);
  while(buffer2 != endptr){
   insert_int_set(A, t);
   buffer2 = endptr;   
   t = strtol(buffer2, &endptr, 10);
  }
  if(first) {taxa=A;}
  free(buffer);
  buffer=(char*) malloc(10000);
  if(!first){
   sp = new_split(); set_split(sp, A, taxa, 1);
   append_list(listsplits, sp);
  }
  first=0;
 }
 assert(taxa);
 *taxa_ = taxa;
}
 
