#include<string.h>
#include<stdio.h>
#include<stdlib.h>
#include<tree2splits.h>
#include<splits2tree.h>
#include<constants.h>
#include<phylo_tree.h>
#include<hashtable.h>
#include<assert.h>
#include<list.h>
#include<split.h>
#include<scm.h>

int VERBOSE=0;

void read_taxa(FILE* fp, list listtaxa);

int main(int argc, char* argv[]){

  char* out_tree;
  FILE* fp; int i, j; 
  phylogenetic_tree* tree_array;
  list* list_array;
  int_set* taxa_array;
  char** num_to_name;
  char** sequences;
  int ntax, nchars;
  hashtable name_to_num;
  int num_trees;
  node v;
  list_node ln, ln2;
  list listtaxa2, listtaxa;
  phylogenetic_tree scm_tree;
  int_set X, A, B, taxa;
  split S; 
  int t, best; char buffer[50]; char newick_tree[1000];

  if(argc < 2){
    printf("Please specify guide tree using \"-gt <filename containing guide_tree>\"\n");
    exit(EXIT_FAILURE);
  }
  for(i = 1; i < argc; i++) {
    if (!strcmp(argv[i], "-t")) {
      i++;
      fp = fopen(argv[i], "r");
      if(!fp) {
        printf("Error: could not open filename \"%s\"\n", argv[i]);
        exit(EXIT_FAILURE);
      }
      listtaxa=new_list();
      read_taxa(fp, listtaxa);
      printf("size of listtaxas=%d\n", size_list(listtaxa));
      fclose(fp);
    }
    else if (!strcmp(argv[i], "-t2")) {
      i++;
      fp = fopen(argv[i], "r");
      if(!fp) {
        printf("Error: could not open filename \"%s\"\n", argv[i]);
        exit(EXIT_FAILURE);
      }
      listtaxa2=new_list();
      read_taxa(fp, listtaxa2);
      printf("size of listtaxas=%d\n", size_list(listtaxa2));
      fclose(fp);
    }
    else if (!strcmp(argv[i], "-v")){
      i++;
      sscanf(argv[i], "%d", &VERBOSE);
    }
    else {
      printf("Please specify dataset using \"-s <filename containing sequences in phylip format>\"\n");
    }
  }
  
  t = 0;
  for(ln = listtaxa->head; ln; ln=ln->next){
    t = 0; printf("searching..\n");
    A = (int_set)ln->data; best=1000000;
    for(ln2=listtaxa2->head; ln2; ln2=ln2->next){
      B = (int_set)ln2->data;
      X = diff_int_set(A, B); 
      if(size_int_set(X) < best) best=size_int_set(X);
      del_int_set(X); 
      X = diff_int_set(B, A);
      if(size_int_set(X) < best) best=size_int_set(X);
      del_int_set(X); 
      if(subseteq_int_set(A, B) || subseteq_int_set(B, A)) { printf("found equal ones\n"); t = 1;}
    } 
    if(!t) { printf("no equal found!, best =%d\n", best); }
  }

}

void read_taxa(FILE* fp, list listtaxa){
 
 int_set A, taxa, B;
 char*  buffer; char* buffer2; char* endptr;
 int t, x, first;
 split sp;

 buffer=(char*) malloc(100000);
 buffer2=(char*) malloc(10);

 endptr=0; first=1;
 while(fgets(buffer, 50000, fp) != NULL){
  A = new_int_set(10);
  buffer2=buffer;
  t = strtol(buffer2, &endptr, 10);
  while(buffer2 != endptr){
   insert_int_set(A, t);
   buffer2 = endptr;   
   t = strtol(buffer2, &endptr, 10);
  }
  free(buffer);
  buffer=(char*) malloc(50000);
  append_list(listtaxa, (void*) A);
 }
}
 
