#This file calls TNT to perform an MP TBR search from a starting tree.
#Copyright (C) 2004 The University of Texas at Austin
#
#This program is free software; you can redistribute it and/or modify it
#under the terms of the GNU General Public License as published by the Free
#Software Foundation; either version 2 of the License, or (at your option)
#any later version.
#
#This program is distributed in the hope that it will be useful, but WITHOUT
#ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
#more details. 
#
#You should have received a copy of the GNU General Public License along
#with this program; if not, write to the Free Software Foundation, Inc., 59
#Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
#
#Email: usman@cs.njit.edu
#Mail: Usman Roshan, Department of Computer Sciences, NJIT-CCS, Computer
#Science Department, GITC 4400, University Heights, Newark, NJ 07102

$f = shift;
$t = shift;
$outtree = shift;
$scorefile = shift;
$fs = shift;

open(OUT, ">TNT_tbr_start_in$fs");
open(IN, $f);
$l = <IN>;
@temp = split(/\s+/, $l);
if ($temp[0] !~ /\d/) {
  $nleaves = $temp[1];
  $seq_length = $temp[2];
}
else {
  $nleaves = $temp[0];
  $seq_length = $temp[1];
}

print OUT "mxram 512;\n";
print OUT "rseed 0;\n";
print OUT "xread\n";
print OUT $seq_length  . " " . $nleaves ."\n";

$map{'A'} = '0'; $map{'C'} = '1'; $map{'G'} = '2'; 
$map{'T'} = '3'; $map{'U'} = '3';
$map{'M'} = "[01]"; $map{'R'} = "[02]"; $map{'W'} = "[03]";
$map{'S'} = "[12]"; $map{'Y'} = "[13]"; $map{'K'} = "[23]";
$map{'V'} = "[012]"; $map{'H'} = "[013]"; $map{'B'} = "[123]"; $map{'D'} = "[023]";
$map{'N'} = "[0123]";

$taxa_ = "";
while(<IN>) {
 chomp $_;
 @temp = split(/\s+/, $_);
 $taxa = $temp[0];
 $taxa_ .= $temp[0] . " ";
 $seq = $temp[1];
 foreach my $x (keys %map){
   $seq =~ s/$x/$map{$x}/g;
 }
 printf OUT "%-20s", $taxa;
 $seq =~ s/[Nn.]/\?/g;
 print OUT $seq ."\n";
}
print OUT ";\n";

system "perl newick_to_tnt_tree.pl $f $t > temptree$fs";
open(TREE,"temptree$fs"); $tree=<TREE>; chomp $tree;
close TREE;
system "/bin/rm temptree$fs";

print OUT "tread\n";
print OUT $tree."\n";
print OUT ";\n";
print OUT "report+60;\n";
print OUT "tsave * TNT_tbr_start_trees$fs;\n";
print OUT "bbreak = nomulpars tbr;\n";
print OUT "save;\n";
print OUT "quit;\n";
close OUT;

system "Tnt bground procedure TNT_tbr_start_in$fs";
system "perl tnt_to_newick_tree.pl $f TNT_tbr_start_trees$fs > TNT_tbr_start_newick_tree$fs";
system "mv TNT_tbr_start_newick_tree$fs $outtree";
system "/bin/rm TNT_tbr_start_in$fs";
system "/bin/rm TNT_tbr_start_trees$fs";
 
system "perl paup_mpscore.pl $f $outtree $scorefile $fs > junk";
system "/bin/rm junk";
open(IN, $scorefile);
$l=<IN>; $l=<IN>; close IN;
chomp $l; @tmp=split(/\s+/, $l);
open(OUT, ">$scorefile");
print OUT $tmp[1]; close OUT;

