#This file converts a newick tree format to a tnt tree formant.
#
#Copyright (C) 2004 The University of Texas at Austin
#
#This program is free software; you can redistribute it and/or modify it
#under the terms of the GNU General Public License as published by the Free
#Software Foundation; either version 2 of the License, or (at your option)
#any later version.
#
#This program is distributed in the hope that it will be useful, but WITHOUT
#ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
#FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for
#more details.
#
#You should have received a copy of the GNU General Public License along with
#this program; if not, write to the Free Software Foundation, Inc., 59 Temple
#Place - Suite 330, Boston, MA 02111-1307, USA.
#
#Email: usman@cs.njit.edu
#Mail: Usman Roshan, Department of Computer Sciences, NJIT-CCS, Computer
#Science Department, GITC 4400, University Heights, Newark, NJ 07102

$d=shift;
$t=shift;

open(DATA,$d);
$l=<DATA>; $i=0;
while(<DATA>){
 @tmp=split(/\s+/,$_);
 $map{$tmp[0]} = $i;
 $i++;
}
close DATA;

open(TREE,$t);
$tree=<TREE>;
while(substr($tree, 0, 1) eq '('){
  $tree =~ s/:\d+\.\d+//g;
  $tree =~ s/:-\d+\.\d+//g;
  $tree =~ s/:\d+//g;
  $newtree="";
  for(my $i=0; $i < length($tree); $i++) {
    $x = substr($tree,$i,1);
    if($x !~ /[\(\)\,\;\s]/) {
      $name = $x;
      $i++;  
      $x = substr($tree,$i,1);
      while($x !~ /[\(\)\,]/) {
	$name .= $x;
	$i++;  
	$x = substr($tree,$i,1);
      }
      $dig = $map{$name};
      $newtree .= $dig . " ";
      $i--;
    }
    else {
      if ($x =~ /[\(\)]/){
	$newtree .= $x;
      }
    }
  }
  print $newtree.";\n";
  $tree = <TREE>;
}
