/*
This file contains subroutines used by the recursive-iterative-dcm3 program.
Copyright (C) 2004 The University of Texas at Austin

This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the Free
Software Foundation; either version 2 of the License, or (at your option)
any later version.

This program is distributed in the hope that it will be useful, but
WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc., 59
Temple Place - Suite 330, Boston, MA 02111-1307, USA.

Email: usman@cs.njit.edu
Mail: Usman Roshan, Department of Computer Sciences, NJIT-CCS, Computer
Science Department, GITC 4400, University Heights, Newark, NJ 07102
*/
#ifndef RECIDCM3
#define RECIDCM3

#include<phylo_tree.h>
#include<hashtable.h>

phylogenetic_tree recursive_dcm3(phylogenetic_tree T, char** sequences, char** num_to_name, hashtable name_to_num, double max_subset_size, char* basecmd, char* basein, char* restricted_gt, char* basetree, int rec_level);

phylogenetic_tree solve_subtree(phylogenetic_tree T, char** sequences, char** num_to_name, hashtable name_to_num, int_set subset_taxa, char* basecmd, char* basein, char* restricted_gt, char* basetree );

phylogenetic_tree global_search(char* globalcmd, char** num_to_name, hashtable name_to_num, int_set full_taxa, double* treescore, char* scorefile, char* globalsearchtree);

#endif
