$seqfile = shift;
$file_suffix = shift;

open(PAUP_FILE, ">tbrinit1_in$file_suffix");
open(SEQ_FILE, $seqfile);
$l = <SEQ_FILE>;
@temp = split(/\s+/, $l);
if ($temp[0] !~ /\d/) {
	$number_of_leaves = $temp[1];
	$seq_length = $temp[2];
}
else {
	$number_of_leaves = $temp[0];
	$seq_length = $temp[1];
}
print PAUP_FILE "#NEXUS;\n";
print PAUP_FILE "begin taxa;\ndimensions ntax=$number_of_leaves".";\n";

$taxa = "";
while(<SEQ_FILE>) {
	@temp = split(/\s+/, $_);
	$taxa .= $temp[0]." ";
}
close SEQ_FILE;

print PAUP_FILE "taxlabels $taxa".";\nend;\n";
print PAUP_FILE "begin characters;\ndimensions nchar=$seq_length".";\n";
print PAUP_FILE "format datatype=nucleotide gap=- missing=?;\nmatrix\n";

open(SEQ_FILE, $seqfile);
$l = <SEQ_FILE>;
while (<SEQ_FILE>) {
	print PAUP_FILE $_;
}

print PAUP_FILE ";\nend;\n";
close SEQFILE;

srand;
$x = rand 100000;
$seed = int $x;

print PAUP_FILE "begin paup;\n";
print PAUP_FILE "set monitor=yes maxtrees=1 increase=no criterion=parsimony;\n";	
print PAUP_FILE "pset collapse=no;\n";	
print PAUP_FILE "hsearch start=stepwise addseq=random nreps=1 swap=tbr hold=1 nchuck=1 chuckscore=1 dstatus=60 timelimit=3600;\n";	
print PAUP_FILE "filter best=yes;\n";
print PAUP_FILE "savetrees file=temptree$file_suffix brlens=yes replace=yes format=phylip;\n";
print PAUP_FILE "quit;\nend;\n";
close PAUP_FILE;

system "paup -n -u tbrinit1_in$file_suffix";
system "/bin/rm tbrinit1_in$file_suffix";

