$f = shift;
$fs = shift;

open(OUT, ">TNT_tbr_in$fs");
open(IN, $f);
$l = <IN>;
@temp = split(/\s+/, $l);
if ($temp[0] !~ /\d/) {
  $nleaves = $temp[1];
  $seq_length = $temp[2];
}
else {
  $nleaves = $temp[0];
  $seq_length = $temp[1];
}

print OUT "rseed 0;\n";
print OUT "xread\n";
print OUT $seq_length  . " " . $nleaves ."\n";

$map{'A'} = '0'; $map{'C'} = '1'; $map{'G'} = '2'; $map{'T'} = '3';
$map{'M'} = "[01]"; $map{'R'} = "[02]"; $map{'W'} = "[03]";
$map{'S'} = "[12]"; $map{'Y'} = "[13]"; $map{'K'} = "[23]";
$map{'V'} = "[012]"; $map{'H'} = "[013]"; $map{'B'} = "[123]"; $map{'D'} = "[023]";
$map{'N'} = "[0123]";

while(<IN>) {
 chomp $_;
 @temp = split(/\s+/, $_);
 $taxa = $temp[0];
 $seq = $temp[1];
 foreach my $x (keys %map){
   $seq =~ s/$x/$map{$x}/g;
 }
 printf OUT "%-20s", $taxa;
 print OUT $seq ."\n";
}
print OUT ";\n";
print OUT "log global_tbr$fs;\n";
print OUT "report+60;\n";
print OUT "tsave * TNT_tbr_trees$fs;\n";
print OUT "mult 1 = hold 1;\n";
print OUT "save;\n";
print OUT "quit;\n";
close OUT;

open (OUT2, ">TNT2_tbr_in$fs");
print OUT2 "mxram 512;\n";
print OUT2 "procedure TNT_tbr_in$fs;\n";
close OUT2;

system "Tnt bground < TNT2_tbr_in$fs";
system "perl tnt_to_newick_tree.pl $f TNT_tbr_trees$fs > TNT_tbr_newick_tree$fs";
system "mv TNT_tbr_newick_tree$fs temptree$fs";
system "/bin/rm TNT_tbr_in$fs TNT2_tbr_in$fs";
